"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.entries = exports.values = exports.keys = exports.shift = exports.has = exports.get = exports.maybeGet = exports.set = exports.of = exports.Cmp = void 0;
const util_1 = require("util");
const RbTree = __importStar(require("./rb-tree.js"));
var Cmp = RbTree.Cmp;
exports.Cmp = Cmp;
const of = (cmp) => ({
    tree: RbTree.of(cmp, (_) => _[0])
});
exports.of = of;
const set = (map, key, value) => RbTree.insert(map.tree, [key, value], 0, _ => _);
exports.set = set;
const maybeGet = (map, key) => RbTree.get(map.tree, key)[0]?.[1];
exports.maybeGet = maybeGet;
const get = (map, key) => {
    const _ = (0, exports.maybeGet)(map, key);
    if (_ === undefined) {
        throw new Error(`Key ${(0, util_1.inspect)(key)} not found.`);
    }
    return _;
};
exports.get = get;
const has = (map, key) => RbTree.has(map.tree, key);
exports.has = has;
/**
 * Deletes left most element.
 * @returns left most element.
 * @throws if map is empty.
 */
const shift = (map) => RbTree.shift(map.tree)[1];
exports.shift = shift;
/**
 * Iterates over keys.
 * Modifications inside iteration are allowed.
 * Iteration will yield keys as they were during initial invocation.
 */
const keys = function* (map) {
    for (const _ of RbTree.each(map.tree)) {
        yield _[0];
    }
};
exports.keys = keys;
const values = function* (map) {
    for (const _ of RbTree.each(map.tree)) {
        yield _[1];
    }
};
exports.values = values;
const entries = function* (map) {
    for (const _ of RbTree.each(map.tree)) {
        yield [_[0], _[1]];
    }
};
exports.entries = entries;
//# sourceMappingURL=map.js.map