"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prelude_js_1 = require("./prelude.js");
const rotate_js_1 = __importDefault(require("./rotate.js"));
const shift = (_) => {
    switch (true) {
        // min_del (T R E x E) = (x,E)
        case _?.c === prelude_js_1.R && _.l === prelude_js_1.E && _.r === prelude_js_1.E: {
            const { v: x, n: i } = _;
            return [x, i, prelude_js_1.E];
        }
        // min_del (T B E x E) = (x,EE)
        case _?.c === prelude_js_1.B && _.l === prelude_js_1.E && _.r === prelude_js_1.E: {
            const { v: x, n: i } = _;
            return [x, i, prelude_js_1.EE];
        }
        // min_del (T B E x (T R E y E)) = (x,T B E y E)
        case _?.c === prelude_js_1.B && _.l === prelude_js_1.E && _.r?.c === prelude_js_1.R && _.r.l === prelude_js_1.E && _.r.r === prelude_js_1.E: {
            const { v: x, n: i, r: { v: y, n: j } } = _;
            return [x, i, (0, prelude_js_1.mk)(prelude_js_1.B, prelude_js_1.E, y, j, prelude_js_1.E)];
        }
        // min_del (T c a x b) = let (x’,a’) = min_del a
        // in (x’,rotate c a’ x b)
        default: {
            const { c, l: a, v: x, n: i, r: b } = _;
            const [x_, n_, a_] = shift(a);
            return [x_, n_, (0, rotate_js_1.default)((0, prelude_js_1.mk)(c, a_, x, i, b))];
        }
    }
};
exports.default = shift;
//# sourceMappingURL=shift.js.map